//The file contains the definitions for the fucntions of the eventlist 
//class such as enqueue and dequeue

//Eventlist is implemented as a linked list

#include <iostream>
using namespace std;
#include "PQE.h"

/***************************************************************************
  PQE() - initializes the values of a PQE node
  Input: eventtime -> time at which the event associated with this PQE 
                      will occur
         eventtype -> Type of the event associated with this element(Timeout, etc)
         eventptr -> Pointer to the event that is associated with this element
***************************************************************************/
PQE::PQE(double eventtime, int eventtype, event *eventptr)
{
  time = eventtime;
  type = eventtype;
  ptr = eventptr;
}

/* eventlist() - is the constructor that initializes the eventlist */
   
eventlist::eventlist()
{
  first = NULL;
}


//dequeue() - Removes and returns the PQE node pointed by header and deletes it 
//            from the list
PQE * eventlist::dequeue()
{
   if(first == NULL)
       return NULL;
   else
   {
      PQEnode *PQEptr;
      PQE *PQEevent = new PQE(first->PQE_node->time, 
	first->PQE_node->type, first->PQE_node->ptr); 
      
      PQEptr = first;
      first = PQEptr->next;
      delete PQEptr;
      PQEptr = NULL;      
      return PQEevent;
   }
}

//enqueue() - Inserts the PQE event node passed in into the eventlist 
//            according to increasing order of event time
// Input: PQE_ptr -> pointer to the PQE to be inserted into the eventlist
// Output: None

void eventlist::enqueue(PQE &PQE_ptr)
{
  PQEnode *PQEeventnode = new PQEnode;

  PQEeventnode->PQE_node = &PQE_ptr;
  
  PQEnode *ptr1, *ptr2;
  int inserted = 0;

  if(first == NULL)           //eventlist is empty
  {
    PQEeventnode->next = NULL;
    first = PQEeventnode;
    inserted = 1;
  }
  else
  {
    ptr1 = first;
    while(ptr1 != NULL)
    {
      if(ptr1->next == NULL)
      {
         ptr2 = ptr1;
         break;
      }
      else if((ptr1->PQE_node->time
	<=PQE_ptr.time)&&(ptr1->next->PQE_node->time > PQE_ptr.time))
      {
         
	 PQEeventnode->next = ptr1->next;
         ptr1->next = PQEeventnode;
	 inserted = 1;
	 break;
      }
      else if(ptr1->PQE_node->time > PQE_ptr.time)
      {
	 PQEeventnode->next = ptr1;
	 first = PQEeventnode;
	 inserted = 1;
	 break;
      }
      else
      {
         ptr2 = ptr1;
         ptr1 = ptr1->next;
      }
    }
  }
  if(inserted == 0)
  {
    ptr2->next = PQEeventnode;
    PQEeventnode->next = NULL;
  }
}

//Makes the eventlist empty. Called when stopping the simulator

void eventlist::destroyeventlist()
{
  PQEnode *ptr1;
  ptr1 = first;
  PQEnode *head = ptr1;
  while(ptr1 != NULL)
  {
    ptr1 = head->next;
    delete head->PQE_node->ptr;
    head->PQE_node->ptr = NULL;
    delete head->PQE_node;
    head->PQE_node = NULL;
    delete head;
    head = NULL;
    head = ptr1;
  }
  first = NULL;
}    
